jQuery(document).ready(function() {
	var intTimeNewest = 0;
	var intTimeOldest = 0;
	
	{
		var dateNewest = null;
		var dateOldest = null;
		
		{
			dateNewest = new Date();
			
			dateNewest = new Date(dateNewest.getFullYear(), dateNewest.getMonth(), dateNewest.getDate(), 23, 59, 59, 999);
		}
		
		{
			dateOldest = new Date();
			
			dateOldest = new Date(dateOldest.getTime() - (7 * 24 * 60 * 60 * 1000));
			
			dateOldest = new Date(dateOldest.getFullYear(), dateOldest.getMonth(), dateOldest.getDate(), 0, 0, 0, 0);
		}
		
		intTimeNewest = dateNewest.getTime();
		intTimeOldest = dateOldest.getTime();
	}
	
	{
		var intHeight = intTimeNewest - intTimeOldest;
		
		intHeight /= 100000;
		
		jQuery('#idCanvas')
			.css({
				'width': 80 + 'px',
				'height': intHeight + 'px'
			})
		;
	}
	
	var contextHandle = jQuery('#idCanvas').get(0).getContext('2d');
	
	{
		contextHandle.canvas.width = jQuery('#idCanvas').width();
		
		contextHandle.canvas.height = jQuery('#idCanvas').height();
	}
	
	{
		var intIndex = 0;
		var intTimeCalendar = intTimeNewest;
		
		do {
			if (intTimeCalendar < intTimeOldest) {
				break;
			}
			
			var intTop = intTimeNewest - intTimeCalendar;
			var intHeight = 24 * 60 * 60 * 1000;
			
			intTop /= 100000;
			intHeight /= 100000;
			
			{
				if ((intIndex % 2) === 0) {
					contextHandle.fillStyle = '#DDDDDD';
					
				} else if ((intIndex % 2) === 1) {
					contextHandle.fillStyle = '#EEEEEE';
					
				}
				
				contextHandle.fillRect(0, intTop, 40, intHeight);
			}
			
			{
				contextHandle.save();
				contextHandle.translate(0.5, 0.5);
				
				for (var intFor1 = 1; intFor1 < 24; intFor1 += 1) {
					var intHour = intTop + Math.floor(intFor1 * (intHeight / 24.0));
					
					{
						contextHandle.lineWidth = 1;
						contextHandle.strokeStyle = '#000000';
						
						contextHandle.beginPath();
						contextHandle.moveTo(33, intHour);
						contextHandle.lineTo(39, intHour);
						contextHandle.stroke();
					}
					
					{
						var strHour = String(24 - intFor1);
						var strMinute = String(0);
						
						if (strHour.length === 1) { strHour = '0' + strHour; }
						if (strMinute.length === 1) { strMinute = '0' + strMinute; }
						
						contextHandle.fillStyle = '#000000';
						
						contextHandle.fillText(strHour + ':' + strMinute, 3, intHour + 3);
					}
				}
				
				contextHandle.restore();
			}
			
			intIndex += 1;
			intTimeCalendar -= 24 * 60 * 60 * 1000;
		} while (true);
	}
	
	{
		contextHandle.fillStyle = '#C3213F';
		
		contextHandle.fillRect(40, 0, 40, contextHandle.canvas.height);
	}
	
	{
		var uptimeHandle = [];
		
		{
			var intIndex = 0;
			var intTimeShutdown = new Date().getTime();
			var intTimeStartup = 0;
			
			{
				jsUptime.acquire();
				
				jsUptime.selectOpen();
				
				do {
					jsUptime.selectNext();
					
					var strIdent = String(jsUptime.getStrIdent());
					var intTime = jsUptime.getIntTime();
					
					if (strIdent === '') {
						break;
					}
					
					if (intTime < intTimeOldest) {
						continue;
					}
					
					if (strIdent === '42') {
						intTimeShutdown = intTime;
					
					} else if (strIdent === '131') {
						intTimeStartup = intTime;
						
						if (intTimeShutdown !== 0) {
							if (intTimeStartup !== 0) {
								uptimeHandle.push({
									'intIndex': intIndex,
									'intTimeShutdown': intTimeShutdown,
									'intTimeStartup': intTimeStartup
								});
							}
						}
						
						intIndex += 1;
						intTimeShutdown = 0;
						intTimeStartup = 0;
						
					}
				} while (true);
				
				jsUptime.selectClose();
				
				jsUptime.release();
			}
		}
		
		for (var intFor1 = 0; intFor1 < uptimeHandle.length; intFor1 += 1) {
			var intIndex = uptimeHandle[intFor1].intIndex;
			var intTimeShutdown = uptimeHandle[intFor1].intTimeShutdown;
			var intTimeStartup = uptimeHandle[intFor1].intTimeStartup;
			
			var intTop = intTimeNewest - intTimeShutdown;
			var intHeight = intTimeShutdown - intTimeStartup;
			
			intTop /= 100000;
			intHeight /= 100000;
			
			{
				contextHandle.fillStyle = '#66C010';
				
				contextHandle.fillRect(40, intTop, 40, intHeight);
			}
			
			{
				var strStartup = '';
				
				{
					var dateStartup = new Date(intTimeStartup);
					
					var strYear = String(dateStartup.getFullYear());
					var strMonth = String(dateStartup.getMonth());
					var strDay = String(dateStartup.getDate());
					var strHour = String(dateStartup.getHours());
					var strMinute = String(dateStartup.getMinutes());
					
					if (strMonth.length === 1) { strMonth = '0' + strMonth; }
					if (strDay.length === 1) { strDay = '0' + strDay; }
					if (strHour.length === 1) { strHour = '0' + strHour; }
					if (strMinute.length === 1) { strMinute = '0' + strMinute; }
					
					strStartup = strYear + '-' + strMonth + '-' + strDay + ' - ' + strHour + ':' + strMinute;
				}
				
				var strShutdown = '';
				
				if (intIndex === 0) {
					strShutdown = 'Running';
					
				} else if (intIndex !== 0) {
					var dateShutdown = new Date(intTimeShutdown);
					
					var strYear = String(dateShutdown.getFullYear());
					var strMonth = String(dateShutdown.getMonth());
					var strDay = String(dateShutdown.getDate());
					var strHour = String(dateShutdown.getHours());
					var strMinute = String(dateShutdown.getMinutes());
					
					if (strMonth.length === 1) { strMonth = '0' + strMonth; }
					if (strDay.length === 1) { strDay = '0' + strDay; }
					if (strHour.length === 1) { strHour = '0' + strHour; }
					if (strMinute.length === 1) { strMinute = '0' + strMinute; }
					
					strShutdown = strYear + '-' + strMonth + '-' + strDay + ' - ' + strHour + ':' + strMinute;
					
				}
				
				var strDuration = '';
				
				{
					var intRunning = intTimeShutdown - intTimeStartup;
					
					var strHours = String(Math.floor(intRunning / (60 * 60 * 1000)));
					var strMinutes = String(Math.floor(intRunning / (60 * 1000)) % 60);
					var strSeconds = String(Math.floor(intRunning / (1000)) % 60);
					
					if (strMinutes.length === 1) { strMinutes = '0' + strMinutes; }
					if (strSeconds.length === 1) { strSeconds = '0' + strSeconds; }
					
					strDuration = strHours + ':' + strMinutes + ':' + strSeconds;
				}
				
				jQuery('#idTable').children('tbody')
					.append(jQuery('<tr></tr>')
						.data({
							'intTop': intTop,
							'intHeight': intHeight
						})
						.append(jQuery('<td></td>')
							.text(strStartup)
						)
						.append(jQuery('<td></td>')
							.text(strShutdown)
						)
						.append(jQuery('<td></td>')
							.addClass('right')
							.text(strDuration)
						)
					)
				;
			}
		}
	}
	
	{
		jQuery('#idTable')
			.dataTable({
				'bFilter': false,
				'bInfo': false,
				'bLengthChange': false,
				'bPaginate': false,
				'bSort': false,
				'oLanguage': {
					'sEmptyTable': '',
					'sZeroRecords': ''
				}
			})
		;
		
		jQuery('#idTable').children('tbody')
			.off('click')
			.on('click', function(eventHandle) {
				var intTop = jQuery(eventHandle.target.parentNode).data('intTop');
				
				window.scrollTo(0, intTop);
			})
		;
		
		jQuery(window)
			.off('scroll')
			.on('scroll', function() {
				var intMin = jQuery(window).scrollTop();
				var intMax = jQuery(window).scrollTop() + jQuery(window).height();
				
				jQuery('#idTable').children('tbody').children('tr').each(function() {
					var intTop = jQuery(this).data('intTop');
					var intHeight = jQuery(this).data('intHeight');
					
					var intTop = 14 + intTop;
					var intBottom = intTop + intHeight;
					
					var boolHighlight = false;
					
					if (intTop > intMin) {
						if (intTop < intMax) {
							boolHighlight = true;
						}
					}
					
					if (intBottom > intMin) {
						if (intBottom < intMax) {
							boolHighlight = true;
						}
					}
					
					if (intTop < intMin) {
						if (intBottom > intMax) {
							boolHighlight = true;
						}
					}
					
					if (boolHighlight === true) {
						jQuery(this)
							.addClass('highlighted')
						;
					
					} else if (boolHighlight === false) {
						jQuery(this)
							.removeClass('highlighted')
						;
						
					}
				});
			})
		;
		
		jQuery(window)
			.trigger('scroll')
		;
	}
});